//------------------------------------------------
//                                  |
//                  defs.h                        |
//         IAR C 1.140            |
//     HISTAR8515/8535 |       
//    .A 12.02.2001  alex_shipov@mail.ru    |
//                 "HISTAR"                  |
//        http://www.chat.ru/~histarcorp          | 
//------------------------------------------------
//FREQ 8000kHz

#include <io8515.h>      /* inc "hard"*/
#include <ina90.h>        
#include "vars.h"
          //DEBUG 
//            
#define  ON     1
#define  OFF    0
#define  FOREVER while(1)
#define  Forever while(1)
#define CLRWDT() _WDR()
#define  STOP  while(1)_WDR; 
         
          //DRIVER 
//              
#define SetBit(Port,bit) Port |= ( 0x01 << bit )
#define ClrBit(Port,bit) Port &= ( ~( 0x01 << bit ) )
#define RdBit(Port,bit) ( Port & ( 0x01 << bit ) )

//  /   
#define WRON      SetBit(PORTD,6)
#define WROFF     ClrBit(PORTD,6)
#define RDON      SetBit(PORTD,7)
#define RDOFF     ClrBit(PORTD,7)

/*-------- INDPR4------*/
// INDPR4   X9 (J2 2 3) 
#define CLKDISPON      SetBit(PORTB,2)
#define CLKDISPOFF     ClrBit(PORTB,2)
#define DIDISPON       SetBit(PORTB,3)
#define DIDISPOFF      ClrBit(PORTB,3)
#define LOADDISPON     SetBit(PORTB,4)
#define LOADDISPOFF    ClrBit(PORTB,4)

//   D8-D11  .
#define  PORTOUT1  0  // .
#define  PORTOUT2  1  // .
#define  PORTIN1   0  // .
#define  PORTIN2   1  // .

//C 2-  AMPIRE 162D
          
#define LCD_RSON     SetBit(PORTB,2) 
#define LCD_RSOFF    ClrBit(PORTB,2)  
#define LCD_ENON     SetBit(PORTB,3)   
#define LCD_ENOFF    ClrBit(PORTB,3)
#define LCD_STROBE   ((LCD_ENON),(LCD_ENOFF))
#define LCDAddr      PORTB
        
//  
#define  string1    0             
#define  string2    0x40  
         
/*--------FLASH24XX------------*/
/*   I2C */

            /*
#define I2CData          P10
#define I2CClock         P11
#define DevAddr24C65     0x00
#define I2CDataLeng      4
              */


        
