//------------------------------------------------
//               3           |
//                  Shamilci.c                    |
//           IAR C 1.41           |
//                  KIT8515                    |       
//    .A 02.12.2000  alex_shipov@mail.ru    |
//                 "HISTAR"                  |
//          http://www.chat.ru/~histarcorp/       | 
//------------------------------------------------
//    KIT8515,  INT0.
//       3-
//   INDPR4,     
//     IBM  COM.(9600)
//   LOAD
// GERKON  KEYSEND   5KOm  +5
//!!!   Small  lnk1s512.xcl    

#include <io8515.h>      /* inc "hard"*/
#include <ina90.h>        
                  
          //FREQ 6000kHz

          //DEBUG 
//            
#define  ON     1
#define  OFF    0
#define  FOREVER while(1)
#define  Forever while(1)
#define CLRWDT() _WDR()
#define  STOP  while(1)_WDR; 
         
         //DRIVER 
//              
#define SetBit(Port,bit) Port |= ( 0x01 << bit )
#define ClrBit(Port,bit) Port &= ( ~( 0x01 << bit ) )
#define RdBit(Port,bit) ( Port & ( 0x01 << bit ) )
        
        //PORT B 
#define DIDISPON       SetBit(PORTB,0)//.  INDPR4 
#define DIDISPOFF      ClrBit(PORTB,0)
#define CLKDISPON      SetBit(PORTB,1)
#define CLKDISPOFF     ClrBit(PORTB,1)
        //PORTD 
#define GERKON         RdBit(PIND,2)// .  
#define KEYSEND        RdBit(PIND,5)//           
        //  62256 (32)
#define BegMem  0x07FF              // 
#define EndMem  0x4000              //  
unsigned int adr=0;                 // 
//    
#define MEM(adr)   ( * ( unsigned char * ) (BegMem +(adr) ) ) 
 
 unsigned char tic=0;      // 
 unsigned char COUNTIMP=0; // 
 unsigned char COUNTMIN;   // 3 
 unsigned char Flag3Min =0;//  3  
 unsigned char FlagInt0;   //  
/*******************************/
/*            INT0             */
/*******************************/
//    
// INT0
interrupt [INT0_vect]void Int1(void)
{
  FlagInt0=1;
  COUNTIMP++;       
 
} 

/*******************************/
/*           TIMER0            */
/*******************************/
interrupt [ TIMER0_OVF0_vect ] void T0Int ( void ) 
{   
 TCNT0=-156;   
 tic++;
  
 if(tic==37)//110
 {
  tic=0;
  COUNTMIN++; 
  if(COUNTMIN==180){COUNTMIN=0;Flag3Min=1;}// 3  
  else
  ;
    }
 else
 ; 
      } 

  


/**********************************/
/*             INIT               */
/**********************************/
 void Init(void)
   {
    //Init PORT
  DDRB =0x1F;
  DDRD = 0xC0;
  PORTD=0x20 ;// 
    
    //Init RS232   
  UBRR =38;//-4800 bode   6000 //38
 
 // UCR =0x98;//18 EN interrupt RXD
  UCR =0x0c;//
  USR =0x80; 
  UDR =' ';    //Clear UDR
   //Init Timer0 
  TCNT0=-156; //    20 
  TCCR0 = 0x05; // CK/1024
  TIMSK = 0x03; //!!!!!!!!8535
  GIMSK = 0x40;//0
  MCUCR = 0x83;//8A      !!!!!!
 _SEI();
        }

/**********************************/
/*            SHOWSYM             */
/**********************************/
unsigned char ShowSym ( unsigned char c )
{
 unsigned char a,f,g;
    switch ( c )
      {
   case '0': a = 0xC0; break;
   case '1': a = 0xF9; break;
   case '2': a = 0xA4 ; break;
   case '3': a = 0xB0; break;
   case '4': a = 0x99 ; break;
   case '5': a = 0x92; break;
   case '6': a = 0x82; break;
   case '7': a = 0xF8; break;
   case '8': a = 0x80; break;
   case '9': a = 0x90; break;
   case 'A': a = 0x88; break;
   case 'B': a = 0x83; break;
   case 'C': a = 0xC6; break;
   case 'D': a = 0xA1; break;
   case 'E': a = 0x86; break;
   case 'F': a = 0x8E; break;
   case 'S': a = 0x92; break;
   case 'N': a = 0xAB; break;     
   case 'L': a = 0xC7; break;     
   case 'R': a = 0xAF; break;     
   case '.': a = 0x7F; break;     
   case '#': a = 0   ; break;//  
   default:return ' ';
      }
//   
//LOADDISPOFF;//  
  
f=a;
for(g=8;g!=0;g--)
{
  if(f & 0x80)
   DIDISPON;// =1;
   else
   {DIDISPOFF;}// =0;
  CLKDISPOFF;//=0;
CLKDISPON;//=1;
  f=f<< 1;
      }
//LOADDISPON;//  
return ' ';
  }//ShowSym

/*******************************/    
/*         CLRDISP             */
/*******************************/
void ClrDisp(void)
{//  INDPR4
 int i;
//LOADDISPOFF;//  
DIDISPON;//=1;
for (i = 32;i!=0;i--)
{
CLKDISPOFF;//=0;
CLKDISPON;//=1;
}
//LOADDISPON ;//  
}


/***********************************/
/*         ShowDigit               */
/***********************************/ 
 
void ShowDigit(unsigned  int Digit)// 9999 
  {
  //     INDPR4
  //   x12
//     
 ClrDisp();         
  if(Digit < 1000) ShowSym(' ');
   else
   ShowSym(48+((Digit/1000)%10));
  if(Digit < 100) ShowSym(' ');
   else
   ShowSym(48+(Digit/100)%10);
  if(Digit < 10) ShowSym(' ');
   else
   ShowSym(48+((Digit/10)%10));
  if(Digit < 1) ShowSym('0');
   else
   ShowSym(48+(Digit%10));
   
}//ShowDigit
        

/**********************************/
/*            DELAYUS             */
/**********************************/

  void DelayUs(unsigned char s)//8-MHZ 100=40MkS
 { //   1-255   
    while(s--);
  }//

/**********************************/
/*            DELAYMS             */
/**********************************/

  void DelayMs(unsigned char m)
 { //   1-255
   unsigned char i=10;
   while(m--){while(i--)DelayUs(6);}
   }
/**********************************/
/*            DELAYS              */
/**********************************/

void DelayS(unsigned char s)        
{//    
  while(s)
  {
  DelayMs(255); 
  DelayMs(255); 
  DelayMs(255); 
  DelayMs(255); 
   s--;
   }
  } 
      
/*********************************/
/*           PUTCHAR             */
/*********************************/
  void PutChar(unsigned char Bait)
   {
   //   RS232       
   UDR=Bait;
   while(!(USR & 0x40));
   USR=USR|0x40;
      } 
    
/*********************************/
/*            GETCHAR            */
/*********************************/
   unsigned char GetChar(void)
 { //   RS232
 while(!(USR & 0x80));return UDR;
 }

/*********************************/
/*          SENDSTATUS           */
/*********************************/

void SendStatus(void)
{ unsigned int i;
    // -  
    for(i=10;i!=0;i--){PutChar('U');}
    //    
    _CLI(); 
    for(i=0;i!=(EndMem-16);i++){PutChar(MEM(BegMem+i));}       
    PutChar('S');
    PutChar('h');
    PutChar('i');
    PutChar('p');
    PutChar('o');
    PutChar('v');
    _SEI();   
           }    
                                
/*********************************/
/*            MAIN               */
/*********************************/
       
 void main (void)
 {unsigned int i;
  
  Init();
  ClrDisp ();
  ShowSym('C');ShowSym('L');ShowSym('R');ShowSym('.');    
  //       ""
  for(i=0;i!=EndMem;i++)
  MEM(BegMem + i)=0;
  DelayS(2);
  
  ShowDigit(COUNTIMP); 
  
    while(1)
    {    
     //  
     if(FlagInt0)
     {FlagInt0=0;ShowDigit(COUNTIMP);}
     else
     ; 
     
      // 3 
      if(Flag3Min)
      {Flag3Min=0;
       //  
       MEM(BegMem + adr)=COUNTIMP; 
       adr++;
       if(adr==EndMem)adr=0;// 16384  
       COUNTIMP=0;
       ShowDigit(COUNTIMP); 
       }
       else
       ;
       
     if(!KEYSEND)  //   "Send"
      {
      ShowSym('S');ShowSym('E');ShowSym('N');ShowSym('D');
      SendStatus();//    RS232   
       while(!KEYSEND);
      ShowDigit(COUNTIMP); 
          }
     else
     ;
          }
 
  }            
