//------------------------------------------------
//          HT1611     |
//                    HT1611.C                    |
//            C IAR   1.40        |
//    HISTAR 8515/8535 |       
//    .A 12.02.2001  alex_shipov@mail.ru    |
//                 "HISTAR"                  |
//         http://www.chat.ru/~histarcorp         | 
//------------------------------------------------
//  
//    9
// 1 - 5V
// 2 - CLK
// 3 - DI
// 4 - LOAD
// 5 - GND
// J12 -(1,2) 

#include "defs.h"
#include "vars.h"

//     X5 J12 d   1-2
// 1 -  
// 2 -CLK
// 3 -DI
// 4-Udd
// 5-Uss 
//    Uss  HK

#include "defs.h"
#include "vars.h"

/*******************************/
/*            SHOWSYM          */
/*******************************/
void ShowSym(char c)
#define MODE       4    
#define SYM        10    
#define SHIFT      4    
#define PAUSE      for(j=3;j!=0;j--);  
 
{ unsigned char Sym,d,j;int i;
  switch(c)
 {
  case ' ': d = 0;break;
  case '1': d = 1;break;
  case '2': d = 2;break; 
  case '3': d = 3;break;
  case '4': d = 4;break;
  case '5': d = 5;break; 
  case '6': d = 6;break;
  case '7': d = 7;break;
  case '8': d = 8;break; 
  case '9': d = 9;break;
  case '0': d = 10;break;
  case 'F': d = 11;break;
  case ']': d = 12;break;
  case '[': d = 13;break;
  case 'P': d = 14;break;
  case '-': d = 15;break;
  default: return;
  }
  d = d << SHIFT; 
        for(i =0;i < MODE;i++)
     {
 CLRWDT();  
        Sym =d;
       if((Sym & 0x80) !=0)
       DIDISPON;
  else  
        DIDISPOFF;
        PAUSE;   
        CLKDISPOFF;
        PAUSE;
        CLKDISPON;
        d=d << 1; 
          }

 CLRWDT();  
  CLKDISPON; 
  DIDISPON;  
    }/*ShowSym*/

/***********************************/
/*            SHOW DIGIT           */
/***********************************/ 
void ShowDigit( unsigned int Digit) 
  { // 5   

 CLRWDT();  
  if(Digit < 10000) ShowSym(' ');
   else
   ShowSym(48+((Digit/10000)%10));
  if(Digit < 1000) ShowSym(' ');
   else
   ShowSym(48+((Digit/1000)%10));
  if(Digit < 100) ShowSym(' ');
   else
   ShowSym(48+(Digit/100)%10);

 CLRWDT();  
  if(Digit < 10) ShowSym(' ');
   else
   ShowSym(48+((Digit/10)%10));
  if(Digit < 1) ShowSym('0');
   else
   ShowSym(48+(Digit%10));
     }//ShowDigit*
/**********************************/    
/*            CLRDISP             */
/**********************************/
void ClrDisp(void)
{int i;
 CLRWDT();  
  for (i = 0;i<SYM;i++)
  ShowSym(' ');
}/*CLrDisp*/

     
