//------------------------------------------------
//        o   |
//                    INDPR4                      |
//            C IAR   1.40        |
//    HISTAR 8515/8535 |       
//    .A 12.02.2001  alex_shipov@mail.ru    |
//                 "HISTAR"                  |
//         http://www.chat.ru/~histarcorp         | 
//------------------------------------------------
//  
//    9
// 1 - 5V
// 2 - CLK
// 3 - DI
// 4 - LOAD
// 5 - GND
// J12 -(2,3) 

#include "defs.h"
#include "vars.h"
/*******************************/
/*         ShowSym             */
/*                             */  
/*******************************/

void ShowSym (unsigned char c )
{
   
   unsigned char a,g;
   CLRWDT(); 
   switch ( c )
      {
   case '0': a = 0xC0; break;
   case '1': a = 0xF9; break;
   case '2': a = 0xA4 ; break;
   case '3': a = 0xB0; break;
   case '4': a = 0x99 ; break;
   case '5': a = 0x92; break;
   case '6': a = 0x82; break;
   case '7': a = 0xF8; break;
   case '8': a = 0x80; break;
   case '9': a = 0x90; break;
   case 'A': a = 0x88; break;
   case 'B': a = 0x83; break;
   case 'C': a = 0xc6; break;
   case 'D': a = 0xa1; break;
   case 'E': a = 0x86; break;
   case 'F': a = 0x8e; break;
   case '.': a = 0x7f; break;
   
   default:return;
      }
    
  //  
for(g=8;g!=0;g--)
{
  CLRWDT();
  if(a & 0x80)
   DIDISPON;
   else
   DIDISPOFF;
CLKDISPOFF;
CLKDISPON;

  a=a<< 1;
    }
LOADDISPON; //  
LOADDISPOFF;
   } //ShowSym


/**********************************/
/*            ClrDisp             */
/**********************************/
void ClrDisp(void)
{unsigned char i;
//     
CLRWDT(); 
DIDISPON;         
  for (i = 32;i!=0;i--)
{
CLKDISPOFF;
CLKDISPON;
}
LOADDISPON;
LOADDISPOFF;

}


/***********************************/
/*         ShowDigit               */
/***********************************/ 
 
void ShowDigit(unsigned int Digit)// 9999 
  {// 4-p 
CLRWDT();
ClrDisp();         
       
  if(Digit < 1000) ShowSym(' ');
   else
   ShowSym(48+((Digit/1000)%10));

  if(Digit < 100) ShowSym(' ');
   else
   ShowSym(48+(Digit/100)%10);

CLRWDT();  
if(Digit < 10) ShowSym(' ');
   else
   ShowSym(48+((Digit/10)%10));

  if(Digit < 1) ShowSym('0');
   else
   ShowSym(48+(Digit%10));
          
}//ShowDigit


