//------------------------------------------------
//           D8-D11|
//                     |
//                   RS232                |
//                   HiRs232.c                    |
//            C IAR   1.40        |
//    HISTAR 8515/8535 |       
//    .A 12.02.2001  alex_shipov@mail.ru    |
//                 "HISTAR"                  |
//         http://www.chat.ru/~histarcorp         | 
//------------------------------------------------
//    INDPR4  
// D8(1-128),D9(1-128),   
// D10,D11  0/255 (0.5e)
//      RS232 9600,8,N,2
// HISTAR 8515 
//    9
// 1 - 5V
// 2 - CLK
// 3 - DI
// 4 - LOAD
// 5 - GND
// J12 -(2,3) 
   
//    !!!            
#include "Defs.h"
#include "vars.h"
#include "indpr4.h"
#include "delay.h"
#include "portio.h" 
#include "rs232.h" 
  
/*********************************/
/*   M A I N  P R O G R A M M    */
/*********************************/
void main(void)
 
    {  
   // 
    DDRB =0x1C;
    MCUCR = 0; //   
   // RS232   
    UBRR =51;//-9600 bode   8000 
   //UCR =0x98;//18 EN interrupt RXD
   UCR =0x0c;//
   USR =0x80; 
    
    //   RS232
    PutChar('H');PutChar('I');PutChar('S');
    PutChar('T');PutChar('A');PutChar('R');  
    ClrDisp();
    ShowDigit(0);
     FOREVER
        {
        unsigned char sym1,sym2;
        
    // 0/1            
    PutPort(PORTOUT1,255);
    PutPort(PORTOUT2,255);
    DelayMs(255);
    PutPort(PORTOUT1,0);
    PutPort(PORTOUT2,0);
    DelayMs(255);
    //     
    sym1=~(GetPort(PORTIN1));
    sym2=~(GetPort(PORTIN2));
    if(sym1!=0){ShowDigit(sym1);PutChar(~sym1);}
    if(sym2!=0){ShowDigit(sym2);PutChar(~sym2);}
    else
    ;
    if(!(sym1||sym2))ShowDigit(0);
       
           }  
  
     }/*main*/
 
 
 






